using Microsoft.AspNetCore.Http;
using System.Text.RegularExpressions;

using SlackAPI;
using System.Text.Json;
using System;
using sera_slackbot.Library;

namespace sera_slackbot.Commands
{
    public class HelloBotCommand : IBotCommand
    {
        private JsonFileSaver saver;
        private string channelId;
        private string userId;
        private string text;
        private string message;
        public HelloBotCommand(JsonFileReader reader, JsonFileSaver saver)
        {
            this.saver = saver;

        }

        public void ExtractValidData(JsonElement slackEvent)
        {
            this.text = slackEvent.GetProperty("text").ToString();
            this.channelId = slackEvent.GetProperty("channel").ToString();
            this.userId = slackEvent.GetProperty("user").ToString();
        }

        public bool WillTrigger(JsonElement slackEvent)
        {
            var text = slackEvent.GetProperty("text").ToString();
            return text.StartsWith("Hello", StringComparison.InvariantCultureIgnoreCase);
        }

        public dynamic Run(SlackClient client)
        {
            var botUserId = new Regex("\u003C.*?\u003E").Matches(text)[0].ToString().Trim('\u003C').Trim('@').Trim('\u003E');

            this.saver.Save("identity.json", botUserId);
            message = $"Oh! Hi, \u003C@{userId}\u003E! It's nice to see you!";
            client.PostMessage(response => { }, channelId, message);
            return new
            {
                code = StatusCodes.Status200OK,
                body = ""
            };
        }
    }
}
